/*
 Circuit:
 * MSP432 LaunchPad  
 * CC3100 WiFi BoosterPack
 * Educational BoosterPack MKII
 * Optional - Battery BoosterPack

 created  January 2017
 by Alexis Crandall
 modified March 2017
 -added static logo to LCD
 */
//#ifndef __CC3200R1M1RGC__
// Do not include SPI for CC3200 LaunchPad if using Energia 18

//#endif
#include <SPI.h>
#include <WiFi.h>
#include <LCD_screen.h>
#include <LCD_screen_font.h>
#include <LCD_utilities.h>
#include <Screen_HX8353E.h>
Screen_HX8353E myScreen;
#include <Terminal12e.h>
#include <Terminal6e.h>
#include <Terminal8e.h>
#include "DSTR_Logo.h"

// Define variables and constants
#define buttonA 33
#define buttonB 32
#define joystickX 2
#define joystickY 26



WiFiUDP Udp;  //creates a named instance of the Wifi UDP class that can send and recieve UDP messages


char ssid[] = "DSTR7";          // your network name also called SSID
char password[] = "dstrdstr";        // your network password
unsigned int localPort = 3553;      // local port to listen on
float valR = 0;                     //varable to hold the right PWM value
float valL = 0;                     //varible to hold the left PWM value
int dirL = 0;                    //variable to hold the left direction
int dirR = 0;                    // variable to hold the right direcion

//this function 
void drawBitmap(const unsigned char *bmp)
{
    uint16_t c;
    uint16_t ca;
    unsigned char cu;
    unsigned char cl;

    uint16_t x = bmp[0]+1;
    uint16_t y = bmp[1]+1;
    
    for (uint16_t yy=0; yy<y; yy++) {
        for (uint16_t xx=0; xx<x; xx++) {
            cu = bmp[(yy*2)*x+5+(xx*2)];
            cl = bmp[(yy*2)*x+5+(xx*2)+1];
            c = cu;
            c = c << 8;
            c |= 0x00FF;
            ca = cl;
            ca |= 0xFF00;
            c &= ca;
            myScreen.point(xx, yy, c);
        }
    }
}
void setup() {
//setup LCD
      myScreen.begin();
    myScreen.setOrientation(0);
    myScreen.clear(whiteColour);
    drawBitmap(DSTR_Launchpad_Logo);
  //Initialize serial and wait for port to open:
    Serial.begin(115200);
  // attempt to connect to Wifi network:
    Serial.print("Attempting to connect to Network named: ");
  // print the network name (SSID);
    Serial.println(ssid); 
  // Connect to WPA/WPA2 network. Change this line if using open or WEP network:
    WiFi.begin(ssid, password);
  while ( WiFi.status() != WL_CONNECTED) {
    Serial.print(".");      // print dots while we wait to connect
    delay(300);
  }
  analogReadResolution(12);  //for the MKII booterPack
  Serial.println("\nYou're connected to the network");
 
  Udp.begin(localPort);
}

void loop() {

     //Redefine the range from 0 to 4096 --> -100 to 100
       int joystickx = map(analogRead(joystickX), 0, 4096, -100, 100);
       int joysticky = map(analogRead(joystickY), 0, 4096, -100, 100);
       
    //Get Direction
      valR = (((joysticky) - joystickx) * 2.55);
      valL = (((joysticky) + joystickx) * 2.55);
      Serial.println(valR);
      Serial.println(valL);
    //make sure ValR and ValL are within the limits to -255 and 255 (makes the analogWrite function MUCH easier on the reciever side)
        if(valR > 255)
          valR = 255;
        if(valL > 255)
          valL = 255;
        if(valR < -255)
          valR = -255;
        if(valL < -255)
          valL = -255;
      Serial.println(valR);
      Serial.println(valL);

        if( valR < 0)
          {
          dirR = 0xBB;
          }
        else
          {
          dirR = 0xAA;
          }
        if(valL < 0)
          {
          dirL = 0xBB;
          }
        else
          {
          dirL = 0xAA;
          }
     //Get Magnitude     
     valR = 255 - abs(valR);
     valL =255 - abs(valL);
    //Create packet
     uint8_t packetBuffer[4] = {dirL,valR,dirR,valL};
    //Send Packet
      Udp.beginPacket( WiFi.gatewayIP(),3553);
       Udp.write(packetBuffer,4);
       Udp.endPacket();

       delay(10);
}


